;----------------------------------------
; html-mode
; $Id: html.el,v 1.4 1996/10/19 12:04:08 sharl Exp $
;----------------------------------------
set $discmd f

store-procedure html-mode
  set $localmap 6
!endm

;;; "
store-procedure html-quote
	insert-string "&quot;"
!endm

;;; &
store-procedure html-ampersand
	insert-string "&amp;"
!endm

;;; >
store-procedure html-greater-than
	insert-string "&gt;"
!endm

;;; <
store-procedure html-less-than
	insert-string "&lt;"
!endm

;;; C-c "
store-procedure html-real-quote
	insert-string "~""
!endm

;;; C-c &
store-procedure html-real-ampersand
	insert-string "&"
!endm

;;; C-c >
store-procedure html-real-greater-than
	insert-string ">"
!endm

;;; C-c <
store-procedure html-real-less-than
	insert-string "<"
!endm

;;; C-c a
store-procedure html-add-address
	insert-string "<address></address>"
	10 backward-character
!endm

;;; C-c C-b
store-procedure html-add-bold
	insert-string "<b></b>"
	4 backward-character
!endm

;;; C-c b
store-procedure html-add-blockquote
	insert-string "<blockquote>"
	2 newline-and-indent
	insert-string "</blockquote>"
	newline-and-indent
	2 previous-line
!endm

;;; C-c c
store-procedure html-add-center
	insert-string "<center>"
	2 newline-and-indent
	insert-string "</center>"
	newline-and-indent
	2 previous-line
!endm

;;; C-c d
store-procedure html-add-description-list
	insert-string "<dl>"
	newline-and-indent
	insert-string "<dt> "
	newline-and-indent
	insert-string "<dd> "
	newline-and-indent
	insert-string "</dl>"
	newline-and-indent
	3 previous-line
	end-of-line
!endm

;;; C-c e
store-procedure html-add-description-entry
	newline-and-indent
	insert-string "<dt> "
	newline-and-indent
	insert-string "<dd> "
	previous-line
!endm

;;; C-c g
store-procedure html-add-img
	!force set $temp @"Image URL: "
	!if &seq $stats FALSE
		!return
	!endif
	insert-string &cat &cat "<img alt=~"~" src=~"" $temp "~">"
!endm

;;; C-c C-h
store-procedure html-add-hairline
	insert-string "<hr>~n"
!endm

;;; C-c h
store-procedure html-add-header
	!force set %%temp @"Size (1-6; 1 biggest): "
	!if &seq $status FALSE
		!return
	!endif
	!force set $temp @"Header: "
	!if &seq $status FALSE
		!return
	!endif
	insert-string &cat &cat &cat &cat "<h" %%temp "></h" %%temp ">"
	5 backward-character
	insert-string $temp
!endm

;;; C-c i
store-procedure html-add-list-or-menu-item
	newline-and-indent
	insert-string "<li> "
!endm

;;; C-c C-i
store-procedure html-add-italic
  insert-string  "<i></i>"
  4 backward-character
!endm

;;; C-c C-l
store-procedure html-add-link-to-region
	!force exchange-point-and-mark
	!if &seq $status FALSE
		!return
	!endif
	!force set $temp @"Link to: "
	!if &seq $status FALSE
		!return
	!endif
	insert-string &cat &cat "<a href=~"" $temp "~">"
	exchange-point-and-mark
	insert-string "</a>"
!endm

;;; C-c l
store-procedure html-add-normal-link
	!force set $temp @"Link to: "
	!if &seq $status FALSE
		!return
	!endif
	insert-string &cat &cat "<a href=~"" $temp "~"></a>"
	4 backward-character
!endm

;;; C-c o
store-procedure html-add-initial-parameter
  insert-string "<html>~n<head>~n<title></title>~n</head>~n<body>~n~n</body>~n</html>"
  2 previous-line
!endm

;;; C-c p
store-procedure html-add-paragraph-separator
	insert-string "<p>~n"
!endm

;;; C-c C-p
store-procedure html-add-preformatted
	insert-string "<pre>"
	2 newline-and-indent
	insert-string "</pre>"
	newline-and-indent
	2 previous-line
!endm

;;; C-c C-r
store-procedure html-add-reference-to-region
  !force exchange-point-and-mark
  !if &seq $status FALSE
  	!return
  !endif
	!force set $temp @"Reference name: "
	!if &seq $status FALSE
		!return
	!endif
	insert-string &cat &cat "<a name=~"" $temp "~">"
	exchange-point-and-mark
	insert-string "</a>"
!endm

;;; C-c r
store-procedure html-add-normal-reference
	!force set $temp @"Reference name: "
	!if &seq $status FALSE
		!return
	!endif
	insert-string &cat &cat "<a name=~"" $temp "~"></a>"
	4 backward-character
!endm

;;; C-c C-s
store-procedure html-add-list
	insert-string "<ul>"
	newline-and-indent
	insert-string "<li> "
	newline-and-indent
	insert-string "</ul>"
	newline-and-indent
	2 previous-line
	end-of-line
!endm

;;; C-c C-v
store-procedure html-add-variable
	insert-string "<var></var>"
	6 backward-character
!endm

;----------------------------------------

6 macro-to-key html-quote "~""
6 macro-to-key html-ampersand "&"
6 macro-to-key html-greater-than >
6 macro-to-key html-less-than <
6 macro-to-key html-real-quote "^C~""
6 macro-to-key html-real-ampersand ^C&
6 macro-to-key html-real-greater-than ^C>
6 macro-to-key html-real-less-than ^C<
6 macro-to-key html-add-address ^Ca
6 macro-to-key html-add-bold ^C^B
6 macro-to-key html-add-blockquote ^Cb
6 macro-to-key html-add-center ^Cc
6 macro-to-key html-add-description-list ^Cd
6 macro-to-key html-add-description-entry ^Ce
6 macro-to-key html-add-img ^Cg
6 macro-to-key html-add-hairline ^C-
6 macro-to-key html-add-hairline ^C^H
6 macro-to-key html-add-header ^Ch
6 macro-to-key html-add-italic ^C^I
6 macro-to-key html-add-list-or-menu-item ^Ci
6 macro-to-key html-add-link-to-region ^C^L
6 macro-to-key html-add-normal-link ^Cl
6 macro-to-key html-add-initial-parameter ^Co
6 macro-to-key html-add-preformatted ^C^P
6 macro-to-key html-add-paragraph-separator ^Cp
6 macro-to-key html-add-reference-to-region ^C^R
6 macro-to-key html-add-normal-reference ^Cr
6 macro-to-key html-add-list ^Cs
6 macro-to-key html-add-variable ^C^V
6 bind-to-key newline-and-indent ^M

set $discmd t
